<?php

namespace Drupal\batch_services;

/**
 * A service for the Batch API.
 */
interface FormHelperInterface {

  /**
   * Creates a batch process.
   *
   * @param string $worker_service_id
   *   The ID for the Batch Worker Service that will process the batch items.
   */
  public function createBatch($worker_service_id);

  /**
   * Prepends a submit callback service to the given render array element.
   *
   * This method must be used to alter the render array element, given Form API
   * limitations concerning callback function argument support.
   *
   * @param mixed $renderArrayElement
   *   The render array element.
   * @param string $service
   *   The service string.
   */
  public function prependSubmitCallbackService(&$renderArrayElement, string $service);

  /**
   * Appends a submit callback service to the given render array element.
   *
   * This method must be used to alter the render array element, given Form API
   * limitations concerning callback function argument support.
   *
   * @param mixed $renderArrayElement
   *   The render array element.
   * @param string $service
   *   The service string.
   */
  public function appendSubmitCallbackService(&$renderArrayElement, string $service);

}
